/***************************************************************************\
**                                                                         **
** WW     WW IIIIIIII NNN   NN DDDDDDD  BBBBBBB     AA     SSSSSS EEEEEEEE **
** WW  W  WW    II    NNNN  NN DD    DD BB    BB  AA  AA  SS      EE       **
** WW  W  WW    II    NN NN NN DD    DD BBBBBBB  AAAAAAAA  SSSSSS EEEEEE   **
**  WW W WW     II    NN  NNNN DD    DD BB    BB AA    AA      SS EE       **
**   WWWWW   IIIIIIII NN   NNN DDDDDDD  BBBBBBB  AA    AA SSSSSS  EEEEEEEE **
**                                                                         **
**  SSSSSS  OOOOOO  FFFFFFFF TTTTTTTT WW     WW    AA    RRRRRRR  EEEEEEEE **
** SS      OO    OO FF          TT    WW  W  WW  AA  AA  RR    RR EE       **
**  SSSSS  OO    OO FFFFF       TT    WW  W  WW AAAAAAAA RRRRRRR  EEEEEE   **
**      SS OO    OO FF          TT     WW W WW  AA    AA RR   RR  EE       **
** SSSSSS   OOOOOO  FF          TT      WWWWW   AA    AA RR    RR EEEEEEEE **
**                                                                         **
********** NOTICE ***********************************************************
**       This file contains valuable trade secrets and proprietary         **
**       assets of Windbase Software Inc.  Embodying substantial           **
**       creative efforts and confidential information.  Unauthorized      **
**       use, copying, decompiling, translating, disclosure or             **
**       transfer, of any kind, is strictly prohibited.                    **
**                                                                         **
**       COPYRIGHT (C) 1992, 1993, 1994, 1995.  Windbase Software Inc.     **
**       ALL RIGHTS RESERVED.                                              **
\***************************************************************************/

/*
** Dict - Non Templates Version
*/

class MyDict : public WBDict
  {
    int WBCompareFunct(void *nullitem, void *item1, void *item2)
      {
	nullitem = nullitem;

	return(strcmp((char *) item1, (char *) item2));
      }

    void *WBCopyFunct(void *nullitem, void *item)
      {
	nullitem = nullitem;

	return(item);
      }

    void WBExecuteFunct(void *nullitem, void *item)
      {
	nullitem = nullitem;

	cout << "Execute: " << (char *) item << "\n";
      }
  };

main()
  {
    MyDict dict, newdict;

    dict += "00";
    dict += "01";
    dict += "02";
    dict += "03";
    dict += "04";
    dict += "05";
    dict += "06";
    dict += "07";
    dict += "08";
    dict += "09";

    cout << "Is Pred: " << dict.IsPred("03") << "\n";
    cout << "Get Pred: " << (char *) dict.GetPred("03") << "\n";
    cout << "Is Succ: " << dict.IsSucc("03") << "\n";
    cout << "Get Succ: " << (char *) dict.GetSucc("03") << "\n";

    newdict.GetRange(dict,"02","05");
    newdict.Execute();

    return(0);
  }
