/*****************************************************************************\
**									     **
**  WW	   WW IIIIIIII NNN   NN	DDDDDDD	 BBBBBBB     AA	    SSSSSS EEEEEEEE  **
**  WW	W  WW	 II    NNNN  NN	DD    DD BB    BB  AA  AA  SS	   EE	     **
**  WW	W  WW	 II    NN NN NN	DD    DD BBBBBBB  AAAAAAAA  SSSSSS EEEEEE    **
**   WW	W WW	 II    NN  NNNN	DD    DD BB    BB AA	AA	SS EE	     **
**    WWWWW   IIIIIIII NN   NNN	DDDDDDD	 BBBBBBB  AA	AA SSSSSS  EEEEEEEE  **
**									     **
**   SSSSSS  OOOOOO  FFFFFFFF TTTTTTTT WW     WW    AA	  RRRRRRR  EEEEEEEE  **
**  SS	    OO	  OO FF		 TT    WW  W  WW  AA  AA  RR	RR EE	     **
**   SSSSS  OO	  OO FFFFF	 TT    WW  W  WW AAAAAAAA RRRRRRR  EEEEEE    **
**	 SS OO	  OO FF		 TT	WW W WW	 AA    AA RR   RR  EE	     **
**  SSSSSS   OOOOOO  FF		 TT	 WWWWW	 AA    AA RR	RR EEEEEEEE  **
**									     **
*********** NOTICE ************************************************************
**	  This file contains valuable trade secrets and	proprietary	     **
**	  assets of Windbase Software Inc.  Embodying substantial	     **
**	  creative efforts and confidential information.  Unauthorized	     **
**	  use, copying,	decompiling, translating, disclosure or		     **
**	  transfer, of any kind, is strictly prohibited.		     **
**									     **
**	  COPYRIGHT (C)	1992, 1993, 1994.  Windbase Software Inc.	     **
**	  ALL RIGHTS RESERVED.						     **
\*****************************************************************************/

#include <stdlib.h>

#define	WBTRC_LEVEL1
#define	WBTRC_LEVEL2

#include "trace.h"

class Trace_Test
  {
    int	i;

    public:

      Trace_Test()
	{
	  WBTrcEntry(0,"Trace_Test::Trace_Test",("No args"));
	  i = 0;
	  WBTrcVReturn(0,("void	return"));
	}

      ~Trace_Test()
	{
	  WBTrcEntry(0,"Trace_Test::~Trace_Test",("No args"));
	  WBTrcVReturn(0,("void	return"));
	}
      void Test1()
	{
	  WBTrcEntry(0,"Trace_Test::Test1",("No	args"));
	  if (i++ < 3)
	    Test1();
	  WBTrcVReturn(0,("void	return"));
	}

      void Test1_2();

      int Test2()
	{
	  WBTrcEntry(0,"Trace_Test::Test1",("No	args"));
	  WBTrcReturn(0,1,("1"));
	}

      int Test2_2();

      void Test3(int test1, char *test2)
	{
	  WBTrcEntry(0,"Trace_Test::Test1",("%d, %s",test1,test2));

	  WBTrcHexDump(0, "test2", test2, 10)

	  WBTrcVReturn(0,("void	return"));
	}

      void Test3_2(int test1, char *test2);

      int Test4(int test1, char	*test2)
	{
	  WBTrcEntry(0,"Trace_Test::Test1",("%d, %s",test1,test2));

	  WBTrcWatch(0,	"test2", test2,	1);

	  *test2 = 't';

	  WBTrcReturn(0,1,("1"));
	}

      int Test4_2(int test1, char *test2);
  };

void Trace_Test::Test1_2()
  {
    WBTrcEntry(0,"Trace_Test::Test1_2",("No args"));
    WBTrcVReturn(0,("void return"));
  }

int Trace_Test::Test2_2()
  {
    WBTrcEntry(0,"Trace_Test::Test2_2",("No args"));
    WBTrcReturn(0,1,("1"));
  }

void Trace_Test::Test3_2(int test1, char *test2)
  {
    WBTrcEntry(0,"Trace_Test::Test3_2",("%d, %s",test1,test2));

    WBTrcHexDump(0, "test2", test2, 10);

    WBTrcVReturn(0,("void return"));
  }

int Trace_Test::Test4_2(int test1, char	*test2)
  {
    WBTrcEntry(0,"Trace_Test::Test4_2",("%d, %s",test1,test2));

    WBTrcWatch(0, "test2", test2, 1);

    *test2 = 't';

    WBTrcReturn(0,1,("1"));
  }

int main(int argc, char	**argv,	char **envp)
  {
    Trace_Test *test;

    WBTrcFrcMainEntry(1);

    test = new Trace_Test;

    test->Test1();
    test->Test1_2();
    test->Test2();
    test->Test2_2();
    test->Test3(1,"Dump	test");
    test->Test3_2(2,"Dump test");
    test->Test4(3,"Watch test");
    test->Test4_2(4,"Watch test");

    delete test;

    WBTrcExit(0,0,("0"));
  }
