/***************************************************************************\
**                                                                         **
** WW     WW IIIIIIII NNN   NN DDDDDDD  BBBBBBB     AA     SSSSSS EEEEEEEE **
** WW  W  WW    II    NNNN  NN DD    DD BB    BB  AA  AA  SS      EE       **
** WW  W  WW    II    NN NN NN DD    DD BBBBBBB  AAAAAAAA  SSSSSS EEEEEE   **
**  WW W WW     II    NN  NNNN DD    DD BB    BB AA    AA      SS EE       **
**   WWWWW   IIIIIIII NN   NNN DDDDDDD  BBBBBBB  AA    AA SSSSSS  EEEEEEEE **
**                                                                         **
**  SSSSSS  OOOOOO  FFFFFFFF TTTTTTTT WW     WW    AA    RRRRRRR  EEEEEEEE **
** SS      OO    OO FF          TT    WW  W  WW  AA  AA  RR    RR EE       **
**  SSSSS  OO    OO FFFFF       TT    WW  W  WW AAAAAAAA RRRRRRR  EEEEEE   **
**      SS OO    OO FF          TT     WW W WW  AA    AA RR   RR  EE       **
** SSSSSS   OOOOOO  FF          TT      WWWWW   AA    AA RR    RR EEEEEEEE **
**                                                                         **
********** NOTICE ***********************************************************
**       This file contains valuable trade secrets and proprietary         **
**       assets of Windbase Software Inc.  Embodying substantial           **
**       creative efforts and confidential information.  Unauthorized      **
**       use, copying, decompiling, translating, disclosure or             **
**       transfer, of any kind, is strictly prohibited.                    **
**                                                                         **
**       COPYRIGHT (C) 1992, 1993, 1994, 1995.  Windbase Software Inc.     **
**       ALL RIGHTS RESERVED.                                              **
\***************************************************************************/

/*
** PQueue - Templates Version
*/

int WBPriorityFunct(void *nullitem, char *item1, char *item2)
  {
    nullitem = nullitem;
    return(*item1-*item2);
  }

int WBCompareFunct(void *nullitem, char *item1, char *item2)
  {
    nullitem = nullitem;
    return(strcmp(item1,item2));
  }

void WBDeleteFunct(void *nullitem, char *item)
  {
    nullitem = nullitem;
    cout << "Delete: " << item << "\n";
  }

main()
  {
    WBPQueue<char *> pqueue(100,0);
    char *item;

    pqueue += "0Item01";
    pqueue += "0Item02";
    pqueue += "1Item03";
    pqueue += "9Item04";
    pqueue += "1Item05";
    pqueue += "5Item06";
    pqueue += "0Item07";
    pqueue += "1Item08";
    pqueue += "9Item09";
    pqueue += "1Item10";
    pqueue += "5Item11";
    pqueue += "0Item12";
    pqueue += "0Item13";
    pqueue += "5Item14";
    pqueue += "9Item15";

    pqueue.Delete("0Item07");
    pqueue -= "1Item08";

    cout << "GetFirst(): " << pqueue.GetFirst() << "\n";
    cout << "Search(): " << pqueue.Search("5Item06") << "\n";

    while ((item = pqueue--) != NULL)
      cout << "GetItem(): " << item << "\n";

    return(0);
  }

